//****************************************************
//***** m6955 control routines   *********************
//*************************** By Minarai Shokunin ****
//*************************** 2014/02/03          ****
//****************************************************

#include "p24FJ64GA002.h"
#include "m6955.h"

extern void I2c_Reg_Write(unsigned int,unsigned char *,unsigned int );
extern void I2c_Reg_Read(unsigned int,unsigned char *,unsigned int);
extern void wait_some(int);
extern int nGlBand;
extern int nGlFreq;
extern int nGlVolume;

char buf[15];

void m6955_init(void);
void m6955_setband(int );
void m6955_setfreq(long );



// *********** M6955 initialize *******************

void m6955_init(void) {
	I2CDIR = 0;			//****
	I2CDAT = 1;		
	I2CCLK = 1;	
	M6955PON = 0;		//**** M6955 PON = L **************
	wait_some(200);
	M6955PON = 1;		//**** M6955 PON = H **************
	buf[0]=0x00;buf[1]=0xc0;I2c_Reg_Write(SA,buf,2);		// Power ON FM MODE
	buf[0]=0x06;buf[1]=0xfd;I2c_Reg_Write(SA,buf,2);		// Volume
	buf[0]=0x07;buf[1]=0x31;I2c_Reg_Write(SA,buf,2);		// 
	buf[0]=0x09;buf[1]=0x07;I2c_Reg_Write(SA,buf,2);		// 
}

void m6955_setband(int band) {
	nGlBand = band;
	if (band < SWMODE1) {
		switch (band) {
			case AMMODE:
					buf[0]=0x00;buf[1]=0x80;I2c_Reg_Write(SA,buf,2); // FM_EN off
					buf[0]=0x01;buf[1]=0x11;I2c_Reg_Write(SA,buf,2); // 522-1620
					break;
			case FMMODE:
					buf[0]=0x00;buf[1]=0xC0;I2c_Reg_Write(SA,buf,2); // FM_EN on
					buf[0]=0x01;buf[1]=0x11;I2c_Reg_Write(SA,buf,2); // FM 76-108 
					break;
			case LWMODE:
					buf[0]=0x00;buf[1]=0x90;I2c_Reg_Write(SA,buf,2); // FM_EN off
					buf[0]=0x01;buf[1]=0x01;I2c_Reg_Write(SA,buf,2); // LW 
					break;
			default :
					break;
		}
	}else{
		buf[0]=0x00;buf[1]=0x80;I2c_Reg_Write(SA,buf,2); // FM_EN off
		buf[0]=0x01;buf[1]=0x01 + (4 + (band - SWMODE1))<< 3 ;I2c_Reg_Write(SA,buf,2); // SW mode set
	}
}

void m6955_setfreq(long freq) {
	int ch;

	switch (nGlBand) {
		case FMMODE:	ch = (freq - 30000) / 25; break;
		case AMMODE:	ch = (freq / 9) * 3; break;
		case LWMODE:	ch = (freq / 9) * 3; break;
		default	: ch = freq / 5;
	}
	buf[0]=0x03;buf[1]= (ch & 0xff) ;I2c_Reg_Write(SA,buf,2); // Set Freq
	buf[0]=0x02;buf[1]= ((ch >> 8) | 0x40);I2c_Reg_Write(SA,buf,2); // Set Freq
	if (nGlBand == FMMODE) {
		buf[0]=0x00;buf[1]=0xE0;I2c_Reg_Write(SA,buf,2); // tune on - FM en
		wait_some(10);
		buf[0]=0x00;buf[1]=0xc0;I2c_Reg_Write(SA,buf,2); // tune off 
		wait_some(10);
	}else{
		buf[0]=0x00;buf[1]=0xA0;I2c_Reg_Write(SA,buf,2); // tune on - FM disable
		wait_some(10);
		buf[0]=0x00;buf[1]=0x80;I2c_Reg_Write(SA,buf,2); // tune off 
		wait_some(10);
	}
}